let titre = document.querySelector("#titre");
titre.innerHTML = "toto";


// BONNE PRATIQUE : avoir un programme principal appelé
// une fois la page chargée (et pas avant)
window.onload = init;

function init() {
    // APPELE QUAND LA PAGE EST CHARGEE
    // sons, videos, images seront definis avant d'arriver là
    console.log("page chargée");
}

// ----- FAIT EN CLASSE POUR VOIR LES OBJETS ET 
// LES TABLEAUX
function test(x) {
    return 12;
}

// OBJET SIMPLE (litteral, ou singleton)
// propriete : valeur,
var p1 = {
    nom: "buffa",
    prenom: "michel",
    getNom() {
        return this.nom;
    },
    decrisToi() {
        return "je suis " + this.getNom();
    }
}

// CLASSES ET INSTANCES
// on n'écrit plus jamais "function"
class Personne {
    constructor(nom, prenom) {
        this.nom = nom;
        this.prenom = prenom;
    }

    getNom() {
        return this.nom;
    }
}

var p2 = new Personne("Buffa", "Michel");
var p3 = new Personne("ALAMI", "Karim");

class Directeur extends Personne {
    constructor(nom, prenom, salaire) {
        super(nom, prenom);
        this.salaire = salaire;
        Directeur.nbDirecteursCrees++;
    }

    getNom() {
        return super.getNom() + " et je suis directeur";
    }
}
Directeur.nbDirecteursCrees = 0;

var p4 = new Directeur("Alami", "Karim", 100000);
console.log(Directeur.nbDirecteursCrees);

var tabPersonnes = [];
tabPersonnes.push(p1, p2, p3, p4);

// iterateur sur tableau
for (let i = 0; i < tabPersonnes.length; i++) {
    let p = tabPersonnes[i];
    console.log(p.getNom());
}

// autre manière
console.log("---------")
tabPersonnes.forEach((p, index) => {
    console.log("Personne no " + index + " " + p.getNom());
});

// supprimer un element
var pos = 2, nbElements = 1; // alami

tabPersonnes.splice(pos, nbElements);
console.log(" ON A SUPPRIME ALAMI ---------")
tabPersonnes.forEach((p, index) => {
    console.log("Personne no " + index + " " + p.getNom());
});

tabPersonnes.push({
    nom: 'toto',
    prenom: "titi",
    getNom() {
        return this.nom;
    }
});

tabPersonnes.forEach((p, index) => {
    console.log("Personne no " + index + " " + p.getNom());
});

